package core.services;

import core.api.models.auth.SimpleStatusResponse;
import org.springframework.http.ResponseEntity;

public class ServiceResult <T> {

    private ServiceExitCode exitCode;
    private T result;

    public ServiceResult(ServiceExitCode exitCode, T result) {
        this.exitCode = exitCode;
        this.result = result;
    }

    public ServiceResult(T result) {
        this.result = result;
        this.exitCode = ServiceExitCode.OK;
    }

    public ServiceResult(ServiceExitCode exitCode) {
        this.exitCode = exitCode;
    }

    public ServiceExitCode getExitCode() {
        return exitCode;
    }

    public void setExitCode(ServiceExitCode exitCode) {
        this.exitCode = exitCode;
    }

    public T getResult() {
        return result;
    }

    public void setResult(T result) {
        this.result = result;
    }

    public boolean hasIssue() {
        return exitCode != ServiceExitCode.OK;
    }

    public ResponseEntity<?> mapToResponseEntity() {
        return exitCode.mapToResponseEntity();
    }
}
